<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>LuckyDiceImagessv2023</title>
    <!-- link to bootstrap css -->
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css">
    <!-- link to bootstrap javascript -->
    <script src="https://code.jquery.com/jquery-3.3.1.slim.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.14.7/umd/popper.min.js"></script>
    <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/js/bootstrap.min.js"></script>
</head>
<style>
    .picture-cover{
        background-image: url("LuckyDiceImagesv2023Feb/ob_cd446b_black-bg-casinodice.jpg");
        min-height: 100px;
        margin: 5px;
    }
</style>
<body>
    <div class="container-fluid picture-cover" >

    </div>

    <div class="container">
        <div class="row">
            <div class="col-5">
                <div class="row form-group">
                    <div class="col-12">
                        <h4>Nhập thông tin của bạn</h4>
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-4">
                        <label>UserName</label>
                    </div>
                    <div class="col-8">
                        <input id="input-username" class="form-control" placeholder="Nhập username của bạn..." type="text">
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-4">
                        <label>FirstName</label>
                    </div>
                    <div class="col-8">
                        <input id="input-firstname" type="text" class="form-control" placeholder="Nhập firstname...">
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-4">
                        <label>LastName</label>
                    </div>
                    <div class="col-8">
                        <input id="input-lastname" type="text" class="form-control" placeholder="Nhập lastname...">
                    </div>
                </div>
            </div>
            <div class="col-4 text-center">
                <div class="row form-group">
                    <div class="col-12">
                       <input id="input-nem" class="btn btn-success button-width w-75" value="Ném Dice" type="button" onclick="onBtnNemClick()">
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-12">
                        <img id="img-dice" src="LuckyDiceImagesv2023Feb/dice_noun_002_10624.jpg" alt="Xúc xắc" class="img-thumbnail" >
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-12">
                        <p id="p-notification-dice">Chúc mừng</p>
                    </div>
                </div>
            </div>
            <div class="col-3 text-center">
                <div class="row form-group">
                    <div class="col-sm-12">
                        <p>Voucher</p>
                        <p id="p-voucher-id">No ID</p>
                        <p id="p-voucher-percent">0%</p>
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-12">
                        <img id="img-percent" class="img-thumbnail" src="LuckyDiceImagesv2023Feb/xe_maymay2.png" slt="xe máy">
                    </div>
                </div>
            </div>
        </div>
        
        <div class="row text-center">
            <div class="col-12">
                <button id="btn-dice-history" class="btn btn-info button-width w-25" onclick="onBtnDiceHistoryClick()">Dice History</button>
                <button id="btn-voucher-history" class=" btn btn-success button-width w-25">Voucher History</button>
                <button id="btn-percen-history" class=" btn btn-success button-width w-25">Percent History</button>
            </div>
        </div>
        <div class="row">
            <div class="col-12">
                <table id="history-placeholder-tabel" class="table table-striped table-hover border">
                    <tr>
                        <th>Lượt</th>
                        <th>Dice</th>
                    </tr>
                    <tr>
                        <td>1</td>
                        <td>2</td>
                    </tr>
                    <tr>
                        <td>2</td>
                        <td>6</td>
                    </tr>
                    <tr>
                        <td>3</td>
                        <td>4</td>
                    </tr>
                    <tr>
                        <td>4</td>
                        <td>5</td>
                    </tr>
                    <tr>
                        <td>5</td>
                        <td>4</td>
                    </tr>
                </table>
            </div>
        </div>
    </div>
</body>
<script>
    //REGION 1
    "use strict";
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const gBASE_URL = "http://203.171.20.210:8080/devcamp-lucky-dice/";
    const gBASE_URL_DICE_HISTORY = "http://203.171.20.210:8080/devcamp-lucky-dice";
    const gUTF8_TEXT_APPLICATION_HEADER = "application/json;charset=UTF-8";
    const gEND_ROW_TABLE = -1;
    //REGION 3
    function onBtnNemClick() {
        //b1 thu thập dữ liệu
        var vGetData =  getData();
        var vIsCheck = validateData(vGetData);
        if(vIsCheck){
            // create a request
            var vXmlHttpDice = new XMLHttpRequest();
            callApiServerDice(vXmlHttpDice, vGetData);
                vXmlHttpDice.onreadystatechange = function () {
                    if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {  //nếu trạng thái của response ready và ok
                        processResponse(vXmlHttpDice);
                    }
                }
            }
    }

    function onBtnDiceHistoryClick(){
        var vGetData = getData();
        var vDuLieuHopLe = validateData(vGetData);
        if(vDuLieuHopLe){
            var vXmlHttpDiceHistory = new XMLHttpRequest();
            callApiServerDiceHistory(vXmlHttpDiceHistory, vGetData);
            vXmlHttpDiceHistory.onreadystatechange = function(){
                if(this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK){
                    changeDataInTable();
                    changeDataDiceHistory(vXmlHttpDiceHistory);
                }
            }
        }
    }
    //REGION 4
    //hàm thu thập dữ liệu
    function getData(){

        var vInputUserName = document.getElementById("input-username");
        var vValueUserName = vInputUserName.value.trim();

        var vInputFirstName = document.getElementById("input-firstname");
        var vValueFirstName = vInputFirstName.value.trim();

        var vInputLastName = document.getElementById("input-lastname");
        var vValueLastName = vInputLastName.value.trim();
        var vUserObject = {
            userName: vValueUserName,
            firstName: vValueFirstName,
            lastName: vValueLastName,
        }
        return vUserObject;
    }
    //hàm kiểm tra dữ liệu
    function validateData(paramObj){
        if(paramObj.userName === ""){
            alert("Hãy nhập username");
            return false;
        }
        if(paramObj.firstName === ""){
            alert("Hãy nhập firstname");
            return false;
        }
        if(paramObj.lastName === ""){
            alert("Hãy nhập lastname");
            return false;
        }
        return true;
    }
    //hàm gọi api dice
    function callApiServerDice(paramXmlHttp, paramDataUser){
        paramXmlHttp.open("POST", gBASE_URL + "/dice", true);
        paramXmlHttp.setRequestHeader("Content-type", gUTF8_TEXT_APPLICATION_HEADER);
        paramXmlHttp.send(JSON.stringify(paramDataUser));
    }
    //hàm gọi api dice history
    function callApiServerDiceHistory(paramXmlHtppDiceHistory,){
        var vElementInputUserName = document.getElementById("input-username");
        var vValueUserName = vElementInputUserName.value.trim();
        paramXmlHtppDiceHistory.open("GET", gBASE_URL_DICE_HISTORY + "/dice-history?username=" + vValueUserName, true);
        paramXmlHtppDiceHistory.send();
    }

    //hàm delete data in table
    function changeDataInTable(){
        //lấy đối tượng table
        var vTable = document.getElementById("history-placeholder-tabel");
        //xóa tất cả data trong table bao gồm cả dòng tiêu đề
        vTable.innerHTML = "";
        //Tạo dòng tiêu đề mới
        var vNewThead = vTable.createTHead();
        var vNewRow = vTable.insertRow();
        var vTh1 = document.createElement("th");
        var vTh2 = document.createElement("th");
        vTh1.innerHTML = "Lượt chơi";
        vTh2.innerHTML = "Số quay được";
        vNewRow.appendChild(vTh1);
        vNewRow.appendChild(vTh2);
        //tạo tbody mới
        var vTbody = vTable.createTBody();
        
    }

    //hàm hiển thị dice history vào table
    function changeDataDiceHistory(paramXmlHttp){
        //chuyển JSON về Obj
        var vJsonObj = JSON.parse(paramXmlHttp.responseText);
        //lấy đối tượng table
        var vTable = document.getElementById("history-placeholder-tabel");
        var vDices = vJsonObj.dices;
        //duyệt qua mảng dice history và tạo dòng mới
        for(var bI = 0; bI < vDices.length; bI++){
            var vRow = vTable.insertRow(gEND_ROW_TABLE);
            var vCell1 = vRow.insertCell(0);
            var vCell2 = vRow.insertCell(1);
            vCell1.innerHTML = bI+ 1;
            vCell2.innerHTML = vDices[bI];
        }
    }

    //hàm xử lý response dice trả về thành công
    function processResponse(paramXmlHttp){
        "use strict";
        console.log(paramXmlHttp.responseText);
        //parsing JSON to Obj
        var vResponseToObj = JSON.parse(paramXmlHttp.responseText);
        console.log(vResponseToObj);
        //get result dice
        var vDiceReady = vResponseToObj.dice;
        console.log("dice result:= " + vDiceReady);
        //gọi hàm hiển thị dice
        changeDice(vDiceReady);
        changeNotification(vDiceReady);
        changeVoucherId(vResponseToObj);
        changeGift(vResponseToObj);
    }
    //hàm hiển thị dice
    function changeDice(paramDice){
        "use strict";
        var vImgDice = document.getElementById("img-dice");
        switch(paramDice){
            case 1: 
                vImgDice.src = "LuckyDiceImagesv2023Feb/1.png";
                break;
            case 2:
                vImgDice.src = "LuckyDiceImagesv2023Feb/2.png";
                break;
            case 3: 
                vImgDice.src = "LuckyDiceImagesv2023Feb/3.png";
                break;
            case 4: 
                vImgDice.src = "LuckyDiceImagesv2023Feb/4.png";
                break;
            case 5: 
                vImgDice.src = "LuckyDiceImagesv2023Feb/5.png";
                break;
            default: 
                vImgDice.src = "LuckyDiceImagesv2023Feb/6.png";
        }
    }
    //hàm hiển thị thông báo
    function changeNotification(paramDice){
        "use strict";
        var vNotification = document.getElementById("p-notification-dice");
        if(paramDice < 4){
            vNotification.innerHTML = "Chúc mừng bạn may mắn lần sau!";
        }
        else{
            vNotification.innerHTML = "Chúc mừng bạn hãy chơi tiếp lần nữa!!!";
        }
    }
    //hàm hiển thị voucher, phần trăm giảm giá
    function changeVoucherId(paramResponseVoucher){
        var vPVoucherId = document.getElementById("p-voucher-id");
        var vPVoucherPercent = document.getElementById("p-voucher-percent");
        if(paramResponseVoucher.voucher != null){
            vPVoucherId.innerHTML = paramResponseVoucher.voucher.maVoucher;
            vPVoucherPercent.innerHTML = paramResponseVoucher.voucher.phanTramGiamGia + "%";
        }
        else{
            vPVoucherId.innerHTML = "";
            vPVoucherPercent.innerHTML = "";
        }
    }
    //hàm hiển thị phần thưởng
    function changeGift(paramResponsePrize){
        var vImgPercent = document.getElementById("img-percent");
        var vTenPhanThuong = paramResponsePrize.prize
        switch(vTenPhanThuong){
            case "Mũ":
                vImgPercent.src = "LuckyDiceImagesv2023Feb/hat.jpg";
            break;
            case "Áo":
                vImgPercent.src = "LuckyDiceImagesv2023Feb/t-shirt.jpg";
            break;
            case "Xe máy":
                vImgPercent.src = "LuckyDiceImagesv2023Feb/xe-may.jpg";
            break;
            case "Ô tô":
                vImgPercent.src = "LuckyDiceImagesv2023Feb/car.jpg";
            break;
            case "Áo mưa":
                vImgPercent.src = "LuckyDiceImagesv2023Feb/ao-mua.jpg";
            break;
            case "Xe đạp":
                vImgPercent.src = "LuckyDiceImagesv2023Feb/bike.jpg";
            break;
            case "Sổ":
                vImgPercent.src = "LuckyDiceImagesv2023Feb/book.jpg";
            break;
            case "Bút":
                vImgPercent.src = "LuckyDiceImagesv2023Feb/but.jpg";
            break;
            default:
                vImgPercent.src = "LuckyDiceImagesv2023Feb/no-present.jpg";
        }
    }




</script>
</html>